local AddonName, TA = ...

-- Config Panel Text Strings
TA.Text={
Title = "Taunt Aware",
TitleSub = "Change how Taunt Aware behaves by setting the options below",
Enable = "Enable the Add On to function",
Full = "Enable full warnings (if you are not a tank)",
AlertSound = "Play a sound when you get a taunt alert",
MF = "Use the Message Frame instead of chat for alerts",
FontSize = "Font Size in message frame                 ",
FadeDelay  = "                            How long the messages display in the frame [1-60 secs]",
TauntsOnly = "Select how to react to high threat actions ( on = ignore, off = tattle, monitor = just alert yourself )",
Links = "Show skill links instead of just skill names",
Scan = "Scan the group for threat increasing abilities when members change",
ScanDelay = "                                    Wait how long after members change for the scan [1-60 secs]",
Tattle = "Alert other people when fight is over to taunts used by non tanks",
TatMode = "How to send the alert [GROUP/WHISPER/SUMMARY](Summary just outputs to you)",
}

-- Bill's Utils
local ChkBox = BillsUtils.ChkBox
local ChkBoxSave = BillsUtils.ChkBoxSave
local CheckClick = BillsUtils.CheckClick
local SliderSave = BillsUtils.SliderSave
local SliderMW = BillsUtils.SliderMW
local Slider = BillsUtils.Slider
local SliderEditBox = BillsUtils.SliderEditBox
local SJprint = BillsUtils.SJprint

BillsUtils.Locals[#BillsUtils.Locals +1] = function ()
	ChkBox = BillsUtils.ChkBox
	ChkBoxSave = BillsUtils.ChkBoxSave
	CheckClick = BillsUtils.CheckClick
	SliderSave = BillsUtils.SliderSave
	SliderMW = BillsUtils.SliderMW
	Slider = BillsUtils.Slider
	SliderEditBox = BillsUtils.SliderEditBox
	SJprint = BillsUtils.SJprint
end


local X = 16 -- standard Horizontal Spacing
local Y = 35 -- standard Vertical spacing 26
local TxtY = 13



-- General Settings / functions
local TAS = TauntAware_Settings
local TAD

TA.ConfigFrame = CreateFrame("Frame")
TA.ConfigFrame:RegisterEvent("ADDON_LOADED")

TA.ConfigFrame:SetScript("OnEvent",function(self, event, ...)
	local arg = ...
	if event ~= "ADDON_LOADED" and arg ~= AddonName then return end
	TAS = TA.TAS
	TAD = TA.TAD
end)

TA.Checkclick = function()
	PlaySound( "GAMEGENERICBUTTONPRESS" )
end

local PlayTestSound = function( sound )
	local file
	if sound >= 2 and sound <= 9 then
		file = "Interface\\AddOns\\TauntAware\\Alert"..tostring(sound - 1)..".mp3"
	elseif sound == 10 then
		file = "Interface\\AddOns\\TauntAware_CustomSounds\\custom.mp3"
	elseif sound == 11 then
		file = "Interface\\AddOns\\TauntAware_CustomSounds\\custom.ogg"
	else
		return
	end
	PlaySoundFile( file )
end

--Panel
TA.panel = CreateFrame( "Frame", "TauntAwareConfig", UIParent )
TA.panel2 = CreateFrame( "Frame", "TauntAwareConfig2", TA.Panel)
local me = TA.panel
local me2 = TA.panel2
me2:SetSize(500, 360)
me2:SetPoint("BOTTOMRIGHT", me, "BOTTOMRIGHT")
me:SetScript("OnLoad", function()
	me.init()
end)


me.name = "Taunt Aware"

-- Panel title
local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
Title:SetPoint( "TOPLEFT", 16, -16 )
Title:SetText( TA.Text.Title )
local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
SubText:SetPoint( "RIGHT", -32, 0 )
SubText:SetHeight( 32 )
SubText:SetJustifyH( "LEFT" )
SubText:SetJustifyV( "TOP" )
SubText:SetText( TA.Text.TitleSub )

-- Scroll Frame
me.ScrollFrame = CreateFrame("ScrollFrame", "TaumtAwareConfigScrollFrame", me, "UIPanelScrollFrameTemplate")
me.ScrollFrame:SetScrollChild(me2)
me.ScrollFrame:SetPoint("TOPRIGHT", me ,"TOPRIGHT", -30,- 64)
me.ScrollFrame:SetPoint("BOTTOMRIGHT", me ,"BOTTOMRIGHT", -30, 10)
me.ScrollFrame:SetPoint("BOTTOMLEFT", me ,"BOTTOMLEFT", 30, 10)

-- Check Boxes & Text
local last = me2
local Command = {"Enable", "Full",}
for x = 1, #Command do
	me[ Command[x] ] = ChkBox( last , "TauntAwareCfg", Command[x] , me2, CheckClick, TA.Text )
	last = me[ Command[x] ]
end


-- AlertSound
local AlertSoundModes = {"off", "alert1.mp3", "alert2.mp3", "alert3.mp3", "alert4.mp3", "alert5.mp3", "alert6.mp3", "alert7.mp3", "alert8.mp3", "custom.mp3", "custom.ogg" }
local AlertSoundChecked = false

local function OnClick(self, arg1)
	UIDropDownMenu_SetSelectedID( UIDROPDOWNMENU_OPEN_MENU, arg1 ) --me.AlertSound, arg1)
	AlertSoundChecked = arg1
	PlayTestSound( arg1 )
end

local function initialize(self, level)
	local info
	for count = 1, #AlertSoundModes  do
		if not( AlertSoundChecked ) and TAS.AlertSound == AlertSoundModes[count] then
			AlertSoundChecked = count
		end
		info = UIDropDownMenu_CreateInfo()
		info.text = AlertSoundModes[count]
		info.arg1 = count
		info.checked = self:GetID() == AlertSoundChecked 
		info.func = OnClick
		UIDropDownMenu_AddButton(info, level)
	end
	
	UIDropDownMenu_SetSelectedID( UIDROPDOWNMENU_INIT_MENU , AlertSoundChecked ) 
end

local AlertSoundText = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
AlertSoundText:SetPoint( "TOPLEFT", last, "BOTTOMLEFT", 0, -0 )
AlertSoundText:SetPoint( "RIGHT", -32, 0 )
AlertSoundText:SetHeight( 32 )
AlertSoundText:SetJustifyH( "LEFT" )
AlertSoundText:SetJustifyV( "CENTER" )
AlertSoundText:SetText( TA.Text.AlertSound )

last = AlertSoundText

me.AlertSound = CreateFrame("Button", "TauntAwareCfgAlertSound", me2, "UIDropDownMenuTemplate") 
me.AlertSound.displayMode = "MENU"
me.AlertSound:ClearAllPoints()
me.AlertSound:SetPoint("TOPLEFT", last, "BOTTOMLEFT", 0, 0)
UIDropDownMenu_Initialize( me.AlertSound, initialize)
UIDropDownMenu_SetWidth( me.AlertSound, 100);
UIDropDownMenu_SetButtonWidth( me.AlertSound, 124)
UIDropDownMenu_JustifyText( me.AlertSound, "LEFT")
		
last = me.AlertSound


-- Message Frame Check Box
me.MF = ChkBox( last , "TauntAwareCfg", "MF" , me2, CheckClick, TA.Text )
last = me.MF

local FontSizeDemo
local SliderFontSize = function(self, delta)
	local min,max = self:GetMinMaxValues()
	local step = self:GetValueStep()
	local value = self:GetValue()

	if delta < 0 then 
		value = value - step
	elseif delta > 0 then
		value = (value + step)
	end
	if value < min then
		value = min
	elseif value > max then
		value = max
	end
	self:SetValue( value )
	FontSizeDemo:SetFont( STANDARD_TEXT_FONT, value )
	FontSizeDemo:SetText( "Font Size Demo "..tostring(value) )
end
	
me.FontSize = Slider( last , "TauntAwareCfg", "FontSize", me2 , SliderFontSize , TA.Text, 7, 24, 1 )
me.FontSize:SetScript( "OnValueChanged", function( self )
	local val = self:GetValue()
	self.Val:SetNumber( val )
	FontSizeDemo:SetFont( STANDARD_TEXT_FONT, val )
	FontSizeDemo:SetText( "Font Size Demo "..tostring( val ) )
	PlaySound( "GAMEGENERICBUTTONPRESS" )
end)
	
last = me.FontSize
me.FontSize.Val = SliderEditBox( last , "TauntAwareCfg", "FontSize", me2 )
	
FontSizeDemo = me2:CreateFontString( "TauntAwareFontSizeDemo", "ARTWORK")
FontSizeDemo:SetFont( STANDARD_TEXT_FONT, 10 )
FontSizeDemo:SetPoint( "TOPLEFT", last, "BOTTOMLEFT", 0, -0 )
FontSizeDemo:SetPoint( "RIGHT", -32, 0 )
FontSizeDemo:SetHeight( 32 )
FontSizeDemo:SetJustifyH( "LEFT" )
FontSizeDemo:SetJustifyV( "CENTER" )
FontSizeDemo:SetText( "Font Size Demo" )

last = FontSizeDemo

me.FadeDelay = Slider( last , "TauntAwareCfg", "FadeDelay", me2 , SliderMW , TA.Text, 1, 60, 1 )
last = me.FadeDelay
me.FadeDelay.Val = SliderEditBox( last , "TauntAwareCfg", "FadeDelay", me2 )

--"TauntsOnly" goes here
local TauntsOnlyModes = {"on", "off", "monitor" }
local TauntsOnlyChecked = false

local function OnClick(self, arg1)
	UIDropDownMenu_SetSelectedID( UIDROPDOWNMENU_OPEN_MENU, arg1)
	TauntsOnlyChecked = arg1
end

local function initialize(self, level)
	local info
	for count = 1, #TauntsOnlyModes  do
		if not(TauntsOnlyChecked) and TAS.TauntsOnly == TauntsOnlyModes[count] then
			TauntsOnlyChecked = count
		end
		info = UIDropDownMenu_CreateInfo()
		info.text = TauntsOnlyModes[count]
		info.arg1 = count
		info.checked = self:GetID() == TauntsOnlyChecked
		info.func = OnClick
		UIDropDownMenu_AddButton(info, level)
	end
	UIDropDownMenu_SetSelectedID( UIDROPDOWNMENU_INIT_MENU , TauntsOnlyChecked ) 
end

local TauntsOnlyText = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
TauntsOnlyText:SetPoint( "TOPLEFT", last, "BOTTOMLEFT", 0, -0 )
TauntsOnlyText:SetPoint( "RIGHT", -32, 0 )
TauntsOnlyText:SetHeight( 32 )
TauntsOnlyText:SetJustifyH( "LEFT" )
TauntsOnlyText:SetJustifyV( "CENTER" )
TauntsOnlyText:SetText( TA.Text.TauntsOnly )

last = TauntsOnlyText

me.TauntsOnly = CreateFrame("Button", "TauntAwareCfgTauntsOnly", me2, "UIDropDownMenuTemplate")
me.TauntsOnly.displayMode = "MENU"
me.TauntsOnly:ClearAllPoints()
me.TauntsOnly:SetPoint("TOPLEFT", last, "BOTTOMLEFT", 0, 0)
UIDropDownMenu_Initialize( me.TauntsOnly, initialize)
UIDropDownMenu_SetWidth( me.TauntsOnly, 100);
UIDropDownMenu_SetButtonWidth( me.TauntsOnly, 124)
UIDropDownMenu_JustifyText( me.TauntsOnly, "LEFT")
		
last = me.TauntsOnly

Command = { "Links", "Scan"}
for x = 1, #Command do
	me[ Command[x] ] = ChkBox( last , "TauntAwareCfg", Command[x] , me2, CheckClick, TA.Text )
	last = me[ Command[x] ]
end
	
me.ScanDelay = Slider( last , "TauntAwareCfg", "ScanDelay", me2 , SliderMW , TA.Text, 1, 60, 1 )
last = me.ScanDelay
me.ScanDelay.Val = SliderEditBox( last , "TauntAwareCfg", "ScanDelay", me2 )
	
me.Tattle = ChkBox( last , "TauntAwareCfg", "Tattle" , me2, CheckClick, TA.Text )
last = me.Tattle

--Tat Mode
local TatModes = {"GROUP", "WHISPER", "SUMMARY" }
local TatModeChecked = false

local function OnClick(self, arg1)
	UIDropDownMenu_SetSelectedID( UIDROPDOWNMENU_OPEN_MENU, arg1)
	TatModeChecked = arg1
end

local function initialize(self, level)
	local info	
	for count = 1, #TatModes  do
		if not(TatModeChecked) and TAS.TatMode == TatModes[count] then
			TatModeChecked = count
		end
		info = UIDropDownMenu_CreateInfo()
		info.text = TatModes[count]
		info.arg1 = count
		info.checked = self:GetID() == TatModesChecked
		info.func = OnClick
		UIDropDownMenu_AddButton(info, level)
	end
	UIDropDownMenu_SetSelectedID( UIDROPDOWNMENU_INIT_MENU , TatModeChecked ) 
end

local TatModeText = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
TatModeText:SetPoint( "TOPLEFT", last, "BOTTOMLEFT", 0, -0 )
TatModeText:SetPoint( "RIGHT", -32, 0 )
TatModeText:SetHeight( 32 )
TatModeText:SetJustifyH( "LEFT" )
TatModeText:SetJustifyV( "CENTER" )
TatModeText:SetText( TA.Text.TatMode )

last = TatModeText

me.TatMode = CreateFrame("Button", "TauntAwareCfgTatMode", me2, "UIDropDownMenuTemplate")
me.TatMode.displayMode = "MENU"
me.TatMode:ClearAllPoints()
me.TatMode:SetPoint("TOPLEFT", last, "BOTTOMLEFT", 0, 0)
UIDropDownMenu_Initialize( me.TatMode, initialize)
UIDropDownMenu_SetWidth( me.TatMode, 100);
UIDropDownMenu_SetButtonWidth( me.TatMode, 124)
UIDropDownMenu_JustifyText( me.TatMode, "LEFT")
		
last = me.TatMode




--	End of frame



-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- X  Init / Reset the config panel to match current settings                                                     X
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--

me.Init = function(...)
	me.Enable:SetChecked( TAS.Enable )
	me.Full:SetChecked( TAS.Full )
	AlertSoundChecked = false
	ToggleDropDownMenu( nil, nil, me.AlertSound ) 
	ToggleDropDownMenu( nil, nil, me.AlertSound )
	me.MF:SetChecked( TAS.MF )
	me.FadeDelay:SetValue( TAS.FadeDelay)
	me.FadeDelay.Val:SetCursorPosition( 0 )
	me.FadeDelay.Val:SetNumber( TAS.FadeDelay )
	me.FontSize:SetValue( TAS.FontSize)
	me.FontSize.Val:SetCursorPosition( 0 )
	me.FontSize.Val:SetNumber( TAS.FontSize )
	TauntsOnlyChecked = false
	ToggleDropDownMenu( nil, nil, me.TauntsOnly ) 
	ToggleDropDownMenu( nil, nil, me.TauntsOnly )
	me.Links:SetChecked( TAS.Links )
	me.Scan:SetChecked( TAS.Scan )
	me.ScanDelay:SetValue( TAS.ScanDelay)
	me.ScanDelay.Val:SetCursorPosition( 0 )
	me.ScanDelay.Val:SetNumber( TAS.ScanDelay )
	me.Tattle:SetChecked( TAS.Tattle )
	TatModeChecked = false
	ToggleDropDownMenu( nil, nil, me.TatMode ) 
	ToggleDropDownMenu( nil, nil, me.TatMode )
end

-- Reset config panel and settings to DEFAULT
me.Reset = function(...)
	local Command = {"Enable", "Full","AlertSound", "MF", "FontSize", "FadeDelay", "TauntsOnly", "AlertTauntsOnly", "TattleTauntsOnly", "Links", "Scan", "ScanDelay", "Tattle", "TatMode"}
	for x = 1, #Command do
		TAS.Command[x] = TAD.Command[x]
	end
	me.Init()
end



me.refresh = function(self)
	me.Init()
end

me.default = function (self)
	me.Reset()
end

me.cancel = function (self)
	me.Init()
end


-- Save settings from config panel
me.okay = function(self)
	local Command = {"Enable", "Full", "MF", "Links", "Scan", "Tattle"}
	for x = 1, #Command do
		ChkBoxSave( me, Command[x], TAS)
	end
	SliderSave( me, "FontSize", TAS) 
	SliderSave( me, "FadeDelay", TAS)
	SliderSave( me, "ScanDelay", TAS)
	
	if TAS.AlertSound ~= AlertSoundModes[AlertSoundChecked] then
		TAS.AlertSound = AlertSoundModes[AlertSoundChecked]
	end
	
	if TAS.TauntsOnly ~= TauntsOnlyModes[TauntsOnlyChecked] then
		TAS.TauntsOnly = TauntsOnlyModes[TauntsOnlyChecked]
	end
	
	if TAS.TatMode ~= TatModes[TatModeChecked] then
		TAS.TatMode = TatModes[TatModeChecked]
	end
	
	
	NickAlert.EventManager()
end

-- Register the config panel
InterfaceOptions_AddCategory( me )
